comment "written by drizz <1of00@gmx.net>"

.const
; User Defined
Dbg_OnAccessViolation		PROTO	:DWORD
Dbg_OnDebugBreak			PROTO
Dbg_OnEnterOEP				PROTO
Dbg_OnIllegalInstruction	PROTO	:DWORD
;because it can happen that you don't use int1 and the app does!
;and int 1 is part of internal stuff
; return false if SetBpm/SetBpx isn't in use 
Dbg_OnBpx				PROTO	:DWORD
Dbg_OnBpr				PROTO	:DWORD
Dbg_OnBpm				PROTO	:DWORD
Dbg_OnDbz				PROTO	:DWORD
;

ClearBpm				PROTO	:DWORD
ClearBpr				PROTO	:DWORD
ClearBpx				PROTO	:DWORD
DbgMain					PROTO	:DWORD
ReadMem					PROTO	:DWORD,:DWORD,:DWORD
ReadMemB				PROTO	:DWORD
ReadMemD				PROTO	:DWORD
SetBpm					PROTO	:DWORD,:DWORD,:DWORD,:DWORD
SetBpr					PROTO	:DWORD,:DWORD,:DWORD
SetBpx					PROTO	:DWORD,:DWORD
ShowRegs				PROTO
Trace					PROTO	:DWORD,:DWORD
WriteMem				PROTO	:DWORD,:DWORD,:DWORD
WriteMemB				PROTO	:DWORD,:DWORD
WriteMemD				PROTO	:DWORD,:DWORD


_a_ textequ <ALIGN DWORD>

TRAP_FLAG equ 100h

; DR7 bits

BPM_L0 equ 1b;local breakpoint enable ; bit 0
BPM_G0 equ 10b;global breakpoint enable ; bit 1
BPM_L1 equ 100b
BPM_G1 equ 1000b
BPM_L2 equ 10000b
BPM_G2 equ 100000b
BPM_L3 equ 1000000b
BPM_G3 equ 10000000b

BPM_LE equ 100000000b;local exact enable ; bit 8
BPM_GE equ 1000000000b;global exact enable ; bit 9

BPM_DETECT equ (1 shl 13);general detect enable ; bit 13

BPM_RW0  equ 16;bit 16,17
BPM_LEN0 equ 18;bit 18,19
BPM_RW1  equ 20
BPM_LEN1 equ 22
BPM_RW2  equ 24
BPM_LEN2 equ 26
BPM_RW3  equ 28;bit 28,29
BPM_LEN3 equ 30;bit 30,31

BPM_EX equ 00b;execute
BPM_WR equ 01b;write
;BPM_IO equ 10b
BPM_RW equ 11b;read/write

BPM_B equ 00b;byte
BPM_W equ 01b;word
BPM_D equ 11b;dword

; DR6 bits

BPM_B0 equ 1b
BPM_B1 equ 10b
BPM_B2 equ 100b
BPM_B3 equ 1000b

BPM_BD equ (1 shl 13);dr access detected  ; bit 13 (if bpm_detect set)
BPM_BS equ (1 shl 14);trap flag trigered 


MAX_BPX equ 32
MAX_BPM equ 4
MAX_BPR equ 4

SS_TRACE equ -1
SS_BP equ 0
SS_RESTORE_BPM equ 1
SS_RESTORE_BPX equ 2
SS_TRACE_ONCE equ 3


TBPX struct
	VA dd ? ;virtual address
	OriginalByte db ?
	Reserved1 db 3 dup(?)
	pHandler dd ?
TBPX ends

TBPM struct
	VA dd ?
	Access db ? 
	Len db ?
	Reserved1 db 2 dup(?)
	pHandler dd ? 
TBPM ends

TBPR struct
	VA dd ?
	Range dd ?
	OldProt dd ? 
	pHandler dd ?
TBPR ends

.data
DoBpx dd FALSE
DoBpm dd FALSE

BREAK_DEBUGGING db FALSE
bDebugBreak db 2
Int3 equ 0CCH
Int3byte db Int3
OEPbyte db 090h
SINGLE_STEP db SS_BP;default


.data?
ctx CONTEXT <>
sinf STARTUPINFO <>
pi PROCESS_INFORMATION <>
de DEBUG_EVENT <>
pNt IMAGE_NT_HEADERS <>
SysInfo SYSTEM_INFO <> 

TargetApp db MAX_PATH dup(?)
tmpbuff db 200h dup (?)

BpxBuff TBPX MAX_BPX dup (<>)
BpmBuff TBPM MAX_BPM dup (<>)
BprBuff TBPR MAX_BPR dup (<>)
LastBpm TBPM <>
LastBpx TBPX <>
LastBpr TBPR <>

dd? TraceHandler,TraceCount

dd? dwDbgStatus,dwFsize,ImageBase,Entrypoint


.code

GetCtx macro
	mov ctx.ContextFlags,CONTEXT_FULL or CONTEXT_DEBUG_REGISTERS
	invoke GetThreadContext,pi.hThread,addr ctx
endm

SetCtx macro
	invoke SetThreadContext,pi.hThread,addr ctx
endm

_a_
ReadMem proc lpAddress:dword, lpBuffer:dword, nSize:dword
	invoke ReadProcessMemory,pi.hProcess,lpAddress,lpBuffer,nSize,0
	mov eax,nSize
	ret  
ReadMem endp

_a_
ReadMemD proc lpAddress:dword
LOCAL dwBuff:dword
	invoke ReadProcessMemory,pi.hProcess,lpAddress,addr dwBuff,sizeof dword,0
	mov eax,dwBuff
	ret
ReadMemD endp 

_a_
ReadMemB proc lpAddress:dword
LOCAL dwBuff:dword
	invoke ReadProcessMemory,pi.hProcess,lpAddress,addr dwBuff,sizeof byte,0
	movzx eax,byte ptr [dwBuff]
	ret
ReadMemB endp 

_a_
WriteMem proc lpAddress:dword, lpBuffer:dword, nSize:dword
LOCAL oldProt:dword
	invoke VirtualProtectEx,pi.hProcess,lpAddress,nSize,PAGE_READWRITE,addr oldProt
	invoke WriteProcessMemory,pi.hProcess,lpAddress,lpBuffer,nSize,0
	invoke VirtualProtectEx,pi.hProcess,lpAddress,nSize,oldProt,addr oldProt
	mov eax,nSize
	ret
WriteMem endp

_a_
WriteMemD proc lpAddress:dword, dwVal:dword
	invoke WriteMem,lpAddress,addr dwVal,sizeof dword
	ret
WriteMemD endp 

_a_
WriteMemB proc lpAddress:dword, dwVal:dword
	and dwVal,0FFh
	invoke WriteMem,lpAddress,addr dwVal,sizeof byte
	ret
WriteMemB endp

_a_
ShowRegs proc
LOCAL szFl[16]:byte
LOCAL Tmpctx:CONTEXT
	pushfd
	pushad
	mov Tmpctx.ContextFlags,CONTEXT_FULL
	invoke GetThreadContext,pi.hThread,addr Tmpctx
	invoke lstrcpy,addr szFl,T('o d i s z a p c')
	mov eax,Tmpctx.regFlag
	xor edx,edx
	test eax, 800h
	setnz dl
	shl edx,5
	sub szFl[0], dl
	test eax, 400h
	setnz dl
	shl edx,5
	sub szFl[2], dl
	test eax, 200h
	setnz dl
	shl edx,5
	sub szFl[4], dl
	test eax, 80h
	setnz dl
	shl edx,5
	sub szFl[6], dl
	test eax, 40h
	setnz dl
	shl edx,5
	sub szFl[8], dl
	test eax, 10h
	setnz dl
	shl edx,5
	sub szFl[10], dl
	test eax, 4
	setnz dl
	shl edx,5
	sub szFl[12], dl
	test eax, 1
	setz dl
	shl edx,5
	sub szFl[14], dl
	invoke Writelnf,T('EAX=%.8X EBX=%.8X ECX=%.8X EDX=%.8X ESI=%.8X   ',13,10,'EDI=%.8X EBP=%.8X ESP=%.8X EIP=%.8X %s',13,10,'CS=%.4X DS=%.4X SS=%.4X ES=%.4X FS=%.4X GS=%.4X'),\
	Tmpctx.regEax,Tmpctx.regEbx,Tmpctx.regEcx,Tmpctx.regEdx,Tmpctx.regEsi,\
	Tmpctx.regEdi,Tmpctx.regEbp,Tmpctx.regEsp,Tmpctx.regEip,addr szFl,\
	Tmpctx.regCs,Tmpctx.regDs,Tmpctx.regSs,Tmpctx.regEs,Tmpctx.regFs,Tmpctx.regGs
	popad
	popfd 
	ret
ShowRegs endp



; === BPX Stuff ===

_a_
SetBpx proc uses esi edi VA:dword, HandlerProc:dword
	assume esi:ptr TBPX
	mov esi,offset BpxBuff
	xor edi,edi
	xor eax,eax
	jmp @F
	.repeat
		inc edi
		.if edi >= MAX_BPX
			or eax,-1
			ret
		.endif
		add esi,Sizeof TBPX
@@:		mov edx,[esi].VA
	.until edx == eax
	invoke ReadMemB,VA
	mov [esi].OriginalByte,al
	invoke WriteMemB,VA,Int3
	m2mr [esi].VA,VA
	m2mr [esi].pHandler,HandlerProc
	mov eax,edi; Return index in buff
	ret
	assume esi:nothing
SetBpx endp

_a_
ClearBpx proc uses esi edi Index:dword
	assume esi:ptr TBPX
	mov edi,Index
	imul edi,sizeof TBPX
	mov esi,offset BpxBuff
	add esi,edi
	.if [esi].VA
		invoke WriteMemB,[esi].VA,dword ptr [esi].OriginalByte
		xor ecx,ecx
		mov [esi].VA,ecx
		mov [esi].pHandler,ecx
		mov [esi].OriginalByte,cl
		GetCtx
		dec ctx.regEip
		SetCtx
	.endif
	ret
	assume esi:nothing
ClearBpx endp

; === BPM Stuff ===

_a_
SetBpm proc uses edi esi ebx VA:dword, Access:dword, Len:dword, HandlerProc:dword
	assume ebx:ptr CONTEXT,esi:ptr TBPM,edi:ptr TBPM
	mov esi,offset BpmBuff
	mov ebx,offset ctx
	GetCtx
	mov edx,Len
	and edx,11b
	shl edx,2; shift length 2 bits left
	mov ecx,Access
	and ecx,11b
	or ecx,edx; condition OR length
	mov eax,VA; eax contains address
	.if ![esi+0*(Sizeof TBPM)].VA
		; dr0 free?
		lea edi,[esi+0*(Sizeof TBPM)].VA
		mov [ebx].iDr0,eax
		shl ecx,16 ; len+rw 0
		or [ebx].iDr7,BPM_L0; local bp in dr0
	.elseif ![esi+1*(Sizeof TBPM)].VA
		; dr1 free?
		lea edi,[esi+1*(Sizeof TBPM)].VA
		mov [ebx].iDr1,eax
		shl ecx,20 ; len+rw 1
		or [ebx].iDr7,BPM_L1; local bp in dr1
	.elseif ![esi+2*(Sizeof TBPM)].VA
		; dr2 free?
		lea edi,[esi+2*(Sizeof TBPM)].VA
		mov [ebx].iDr2,eax
		shl ecx,24 ; len+rw 2
		or [ebx].iDr7,BPM_L2; local bp in dr2
	.elseif ![esi+3*(Sizeof TBPM)].VA
		; dr3 free?
		lea edi,[esi+3*(Sizeof TBPM)].VA
		mov [ebx].iDr3,eax
		shl ecx,28 ; len+rw 3
		or [ebx].iDr7,BPM_L3; local bp in dr3
	.else
		; no free dr
		or eax,-1
		ret   
	.endif
	or [ebx].iDr7,ecx
	or [ebx].iDr7,BPM_LE; just Local task bp
	mov [edi].VA,eax
	m2mr [edi].pHandler,HandlerProc
	movzx eax,byte ptr Len
	movzx edx,byte ptr Access
	mov [edi].Len,al; byte, word, dword
	mov [edi].Access,dl; read/write, write, execute
	SetCtx
	xor eax,eax
	ret
	assume edi:nothing,esi:nothing,ebx:nothing
SetBpm endp

_a_
ClearBpm proc uses esi edi drX:dword; 0..3
	assume edi:ptr CONTEXT,esi:ptr TBPM
	GetCtx
	mov ecx,drX
	mov edi,offset ctx
	mov eax,ecx
	imul eax,Sizeof TBPM; get offset in buff
	lea esi,BpmBuff[eax]
	xor edx,edx
	mov [esi].VA,edx; set to zero
	mov [esi].pHandler,edx;-||-
	mov [esi].Access,dl;-||-
	mov [esi].Len,dl;-||-
	.if ecx == 0; dr0?
		mov [edi].iDr0,edx
		and [edi].iDr7,not BPM_L0    
	.elseif ecx == 1; dr1?
		mov [edi].iDr1,edx
		and [edi].iDr7,not BPM_L1
	.elseif ecx == 2; dr2?
		mov [edi].iDr2,edx
		and [edi].iDr7,not BPM_L2
	.elseif ecx == 3; dr3?
		mov [edi].iDr3,edx
		and [edi].iDr7,not BPM_L3
	.endif
	SetCtx
	ret
	assume edi:nothing,esi:nothing
ClearBpm endp

; === BPR Stuff ===

_a_
SetBpr proc uses esi edi VA:dword, Range:dword, HandlerProc:dword
	assume esi:ptr TBPR
	mov esi,offset BprBuff
	xor eax,eax
	jmp @F
	.repeat
		inc edi
		.if edi>=MAX_BPR
			or eax,-1
			ret
		.endif
		add esi,Sizeof TBPR
@@:		mov edx,[esi].VA
	.until edx==eax
	m2mr [esi].VA,VA
	m2mr [esi].Range,Range
	m2mr [esi].pHandler,HandlerProc
	invoke VirtualProtectEx,pi.hProcess,VA,Range,PAGE_GUARD or PAGE_READONLY,addr [esi].OldProt
	xor eax,eax
	ret
	assume esi:nothing
SetBpr endp

_a_
ClearBpr proc uses esi Index:dword
LOCAL tmpProt:dword
	assume esi:ptr TBPR
	mov esi,offset BprBuff
	mov eax,Index
	imul eax,sizeof TBPR
	add esi,eax
	invoke VirtualProtectEx,pi.hProcess,[esi].VA,[esi].Range,[esi].OldProt,addr tmpProt
	xor eax,eax
	mov [esi].VA,eax
	mov [esi].Range,eax
	mov [esi].OldProt,eax
	ret
	assume esi:nothing
ClearBpr endp

; === TRACE Stuff ===

_a_
Trace proc trCount,trHandler
	m2mr TraceCount,trCount
	m2mr TraceHandler,trHandler
	GetCtx
	mov SINGLE_STEP,SS_TRACE
	or ctx.regFlag,TRAP_FLAG
	SetCtx
	ret
Trace endp

; === Debug Event handlers ===

_a_
DbgCreateProcess proc uses ebx cpdi:ptr CREATE_PROCESS_DEBUG_INFO
LOCAL nbr:dword
LOCAL pDos:IMAGE_DOS_HEADER
	mov ebx,cpdi  
	assume ebx:ptr CREATE_PROCESS_DEBUG_INFO
	invoke Writeln,T('> Process Created')
	m2mr ImageBase,[ebx].lpBaseOfImage
	invoke ReadFile,[ebx].hFile,addr pDos,sizeof IMAGE_DOS_HEADER,addr nbr,0
	invoke SetFilePointer,[ebx].hFile,pDos.e_lfanew,0,FILE_BEGIN
	invoke ReadFile,[ebx].hFile,addr pNt,sizeof IMAGE_NT_HEADERS,addr nbr,0
	invoke Writelnf,T('Entrypoint  : %.8X'),[ebx].lpStartAddress
	m2mr Entrypoint,[ebx].lpStartAddress
	invoke Writelnf,T('ImageBase   : %.8X'),[ebx].lpBaseOfImage
	invoke Writelnf,T('SizeOfImage : %.8X'),pNt.OptionalHeader.SizeOfImage
	invoke GetFileSize,[ebx].hFile,0
	mov dwFsize,eax
	invoke Writelnf,T('FileSize    : %lu bytes'),eax
	mov dwDbgStatus,DBG_CONTINUE
	assume ebx:nothing
	ret
DbgCreateProcess endp

_a_
DbgExitProcess proc epdi:ptr EXIT_PROCESS_DEBUG_INFO
	invoke Writeln,T('> Process Terminated')
	mov dwDbgStatus,DBG_CONTINUE
	or BREAK_DEBUGGING,TRUE
	ret
DbgExitProcess endp

_a_
DbgOutputString proc odsi:ptr OUTPUT_DEBUG_STRING_INFO
LOCAL debugeestr[200h]:byte
	mov edx,odsi
	mov debugeestr[0],0
	invoke ReadMem,[edx].OUTPUT_DEBUG_STRING_INFO.lpDebugStringData,addr debugeestr,sizeof debugeestr
	invoke Writelnf,T('> DebugeeString',13,10,' : %s'),addr debugeestr
	mov dwDbgStatus,DBG_CONTINUE
	ret
DbgOutputString endp

_a_
DbgLoadDll proc uses ebx lddi:ptr LOAD_DLL_DEBUG_INFO
LOCAL dllname[MAX_PATH]:byte
LOCAL dllnamea[MAX_PATH]:byte
	mov ebx,lddi
	assume ebx:ptr LOAD_DLL_DEBUG_INFO
	xor eax,eax
	mov dword ptr dllname[0],eax
	.if [ebx].lpImageName == eax
	@@: 
		invoke Writelnf,T('> Dll load :: ??? :: @%.8X'),addr dllname,[ebx].lpBaseOfDll
	.else
		invoke ReadMemD,[ebx].lpImageName
		.if eax
			lea edx,dllname
			invoke ReadMem,eax,edx,sizeof dllname
			.if [ebx].fUnicode
				invoke WideCharToMultiByte,CP_OEMCP,0,addr dllname,-1,addr dllnamea,sizeof dllnamea,0,0
			.endif
			invoke Writelnf,T('> Dll load :: %s :: @%.8X'),addr dllnamea,[ebx].lpBaseOfDll
		.else
			jmp @B
		.endif
	.endif
	assume ebx:NOTHING  
	mov dwDbgStatus,DBG_CONTINUE
	ret
DbgLoadDll endp

_a_
DbgUnloadDll proc uses ebx uddi:ptr UNLOAD_DLL_DEBUG_INFO
	mov ebx,uddi
	assume ebx:ptr UNLOAD_DLL_DEBUG_INFO
	invoke Writelnf,T('> Dll unload :: @%.8X'),[ebx].lpBaseOfDll
	assume ebx:NOTHING
	mov dwDbgStatus,DBG_CONTINUE 
	ret
DbgUnloadDll endp

_a_
DbgCreateThread proc uses ebx ctdi:ptr CREATE_THREAD_DEBUG_INFO
	mov ebx,ctdi
	assume ebx:ptr CREATE_THREAD_DEBUG_INFO
	invoke Writelnf,T('> Thread created ( start address : %.8X )'),[ebx].lpStartAddress
	assume ebx:NOTHING
	mov dwDbgStatus,DBG_CONTINUE 
	ret	
DbgCreateThread endp

_a_
DbgExitThread proc uses ebx etdi:ptr EXIT_THREAD_DEBUG_INFO
	mov ebx,etdi
	assume ebx:ptr EXIT_THREAD_DEBUG_INFO
	invoke Writelnf,T('> Thread terminated ( exit code : %.8X )'),[ebx].dwExitCode
	assume ebx:NOTHING
	mov dwDbgStatus,DBG_CONTINUE 
	ret	
DbgExitThread endp

_a_
DbgRIP proc uses ebx ri:ptr RIP_INFO
	mov ebx,ri
	assume ebx:ptr RIP_INFO
	invoke Writelnf,T('> RIP ( Error : %.8X )'),[ebx].dwError
	assume ebx:NOTHING
	mov dwDbgStatus,DBG_CONTINUE 
	or BREAK_DEBUGGING,TRUE
	ret
DbgRIP endp

_a_
DbgException proc uses esi edi ebx exdi:ptr EXCEPTION_DEBUG_INFO
	mov ebx,exdi
	assume ebx:ptr EXCEPTION_DEBUG_INFO
	.if [ebx].pExceptionRecord.ExceptionCode == EXCEPTION_BREAKPOINT
	; # BPX ########################################################
		mov al,bDebugBreak
		.if al
			; internal
			.if al == 2
				; do some stuff on startup (kill anti debug :)
				invoke Dbg_OnDebugBreak
				invoke ReadMemB,Entrypoint
				mov OEPbyte,al
				invoke WriteMemB,Entrypoint,Int3
			.elseif al == 1
				movzx eax,OEPbyte
				invoke WriteMemB,Entrypoint,eax
				GetCtx
				dec ctx.regEip
				SetCtx
				; do some stuff on OEP (set breakpoints :)
				invoke Dbg_OnEnterOEP
			.endif
			dec bDebugBreak
		.else
			; Bpx Dispatcher
			mov esi,offset BpxBuff
			xor edi,edi
			mov eax,[ebx].pExceptionRecord.ExceptionAddress
			jmp @F
			.repeat
				inc edi
				.if edi>=MAX_BPX
					invoke Dbg_OnBpx,[ebx].pExceptionRecord.ExceptionAddress
					test eax,eax;FALSE if you don't handle it
					jz @@Unhandled
					jmp @@Exit
				.endif
				add esi,Sizeof TBPX
		@@:		mov edx,[esi].TBPX.VA
			.until edx==eax
			push [ebx].pExceptionRecord.ExceptionAddress
			call dword ptr [esi].TBPX.pHandler; must return bool
		 	.if eax == TRUE ; Continiuous
				; store bpx to lastbpx	
				mov edx,offset LastBpx
				mov ecx,[esi].TBPX.VA
				mov [edx].TBPX.VA,ecx
				mov cl,[esi].TBPX.OriginalByte
				mov [edx].TBPX.OriginalByte,cl
				mov ecx,[esi].TBPX.pHandler
				mov [edx].TBPX.pHandler,ecx
				; trace over once
	 			GetCtx
				mov SINGLE_STEP,SS_RESTORE_BPX 
				or ctx.regFlag,TRAP_FLAG
				SetCtx
		 	.endif
	 	 	invoke ClearBpx,edi
		.endif

	.elseif [ebx].pExceptionRecord.ExceptionCode == EXCEPTION_SINGLE_STEP
	; # BPM #############################################################
		GetCtx
		.if (ctx.iDr6 & BPM_BS) ; al != SS_BP
			mov al,SINGLE_STEP
			.if al == SS_RESTORE_BPM
				movzx eax,LastBpm.Access
				movzx edx,LastBpm.Len
				invoke SetBpm,LastBpm.VA,eax,edx,LastBpm.pHandler
				mov SINGLE_STEP,SS_BP
			.elseif al == SS_RESTORE_BPX
				invoke SetBpx,LastBpx.VA,LastBpx.pHandler
				mov SINGLE_STEP,SS_BP
			.elseif al == SS_TRACE ; WE ARE TRACING
				mov eax,TraceCount
				.if eax > 0
					mov eax,TraceHandler
					.if eax != NULL; pointer
						call eax; call handler
						.if eax == FALSE ; return false to stop trace
							mov TraceCount,1; decremented below
						.endif
					.endif
					dec TraceCount
					.if !ZERO?
						; then do it again,and again... 
						GetCtx
						mov SINGLE_STEP,SS_TRACE
						or ctx.regFlag,TRAP_FLAG
						SetCtx
					.endif
				.endif
			.else
				invoke Dbg_OnBpm,[ebx].pExceptionRecord.ExceptionAddress
				test eax,eax;FALSE if you don't handle it
				jz @@Unhandled
			.endif
		.else; HARDWARE BREAKPOINTS
			mov edx,ctx.iDr6
			or edi,-1
			and edx,1111b
			.repeat;		.if edx & BPM_B0
				inc edi;	.elseif edx & BPM_B1
				shr edx,1;	.elseif edx & BPM_B2
			.until ZERO?;	.elseif edx & BPM_B3
			mov eax,edi
			imul eax,sizeof TBPM
			lea esi,BpmBuff[eax]
			mov eax,[esi].TBPM.pHandler
			.if !eax; be sure its' not your error 
				invoke Dbg_OnBpm,[ebx].pExceptionRecord.ExceptionAddress
				test eax,eax;FALSE if you don't handle it
				jz @@Unhandled
			.endif
			push [ebx].pExceptionRecord.ExceptionAddress
			call eax
		 	.if eax == TRUE  ;Continiuous
				mov edx,offset LastBpm
				mov ecx,[esi].TBPM.VA
				mov [edx].TBPM.VA,ecx
				mov cl,[esi].TBPM.Access
				mov [edx].TBPM.Access,cl
				mov cl,[esi].TBPM.Len
				mov [edx].TBPM.Len,cl
				mov ecx,[esi].TBPM.pHandler
				mov [edx].TBPM.pHandler,ecx
				; trace over once
	 			GetCtx
				mov SINGLE_STEP,SS_RESTORE_BPM
				or ctx.regFlag,TRAP_FLAG
				SetCtx
		 	.endif
	 		invoke ClearBpm,edi
		.endif;SINGLE_STEP 

	.elseif [ebx].pExceptionRecord.ExceptionCode == STATUS_GUARD_PAGE_VIOLATION
	; # BPR ###################################################################
		mov ecx,[ebx].pExceptionRecord.ExceptionAddress
		mov eax,SysInfo.lpMaximumApplicationAddress
		mov edx,SysInfo.lpMinimumApplicationAddress
		.if ecx > eax || ecx < edx
			jmp @@Unhandled
		.endif
		mov esi,offset BprBuff
		xor edi,edi
		mov ecx,[ebx].pExceptionRecord.ExceptionAddress
		.while TRUE
			cmp edi,MAX_BPR
			jae @@Unhandled
			mov eax,[ebx].pExceptionRecord.ExceptionAddress
			.if eax >= [esi].TBPR.VA
				sub eax,[esi].TBPR.VA
				.break .if eax <= [esi].TBPR.Range
			.endif
			add esi,Sizeof TBPR
			inc edi
		.endw
		push [ebx].pExceptionRecord.ExceptionAddress
		call dword ptr [esi].TBPR.pHandler
		invoke ClearBpr,edi
		
	.elseif [ebx].pExceptionRecord.ExceptionCode == EXCEPTION_ACCESS_VIOLATION
	; # AV ###################################################################
		mov ecx,[ebx].pExceptionRecord.ExceptionAddress
		mov eax,SysInfo.lpMaximumApplicationAddress
		mov edx,SysInfo.lpMinimumApplicationAddress
		.if ecx > eax || ecx < edx
			jmp @@Unhandled
		.endif
		invoke Dbg_OnAccessViolation,ecx
		test eax,eax;FALSE if you don't handle it
		jz @@Unhandled
	.elseif [ebx].pExceptionRecord.ExceptionCode == STATUS_ILLEGAL_INSTRUCTION
		invoke Dbg_OnIllegalInstruction,[ebx].pExceptionRecord.ExceptionAddress
		test eax,eax;FALSE if you don't handle it
		jz @@Unhandled
	.elseif [ebx].pExceptionRecord.ExceptionCode == EXCEPTION_INT_DIVIDE_BY_ZERO	
		invoke Dbg_OnDbz,[ebx].pExceptionRecord.ExceptionAddress
		test eax,eax;FALSE if you don't handle it
		jz @@Unhandled
	.else
@@Unhandled:
;		invoke Writelnf,T('UNHANDLED EXCEPTION @: %.8X'),[ebx].pExceptionRecord.ExceptionAddress
		mov dwDbgStatus,DBG_EXCEPTION_NOT_HANDLED
		ret
	.endif
@@Exit:
	mov dwDbgStatus,DBG_CONTINUE
	assume ebx:nothing
	ret
DbgException endp

_a_
DbgMain proc pTargetApp
	invoke StrCpy,addr TargetApp,pTargetApp
	invoke ZeroMemory,addr pi,sizeof pi
	invoke GetSystemInfo,addr SysInfo
	invoke GetStartupInfo,addr sinf
	invoke CreateProcess,0,addr TargetApp,0,0,FALSE,DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS,0,0,addr sinf,addr pi
	.if eax
		.while TRUE    
			invoke WaitForDebugEvent,addr de,INFINITE
			mov dwDbgStatus,DBG_CONTINUE
			mov eax,de.dwDebugEventCode
			lea edx,de.u
			push edx
			push offset @@retaddr
			jmp [offset @@jmptable + 4*eax - 4]
				align dword
		@@jmptable:
			; MANUALLY SET FOR NOW 
			;--------------------------------
				dd offset DbgException;dd offset @@default;MUST
			;--------------------------------
				;dd offset DbgCreateThread
				dd offset @@default
			;--------------------------------
				dd offset DbgCreateProcess;dd offset @@default;MUST 
			;--------------------------------
				;dd offset DbgExitThread
				dd offset @@default
			;--------------------------------
				dd offset DbgExitProcess;dd offset @@default;MUST
			;--------------------------------
				;dd offset DbgLoadDll
				dd offset @@default
			;--------------------------------
				;dd offset DbgUnloadDll
				dd offset @@default
			;--------------------------------
				;dd offset DbgOutputString
				dd offset @@default
			;--------------------------------
				;dd offset DbgRIP
				dd offset @@default
			;--------------------------------
		@@default:
				retn 1*4
		@@retaddr:
			invoke ContinueDebugEvent,de.dwProcessId,de.dwThreadId,dwDbgStatus; see win32.hlp Remarks
			.break .if BREAK_DEBUGGING
		.endw
	.else
		invoke Writeln,T('CreateProcess Error')
	.endif
	ret
DbgMain endp
